unit HostBattleFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, ComCtrls, janTracker, Buttons;

type
  THostBattleForm = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Button3: TButton;
    PortEdit: TEdit;
    Label2: TLabel;
    PasswordEdit: TEdit;
    Label3: TLabel;
    PlayersTracker: TjanTracker;
    TitleEdit: TEdit;
    Label4: TLabel;
    ModsComboBox: TComboBox;
    Label5: TLabel;
    SpeedButton1: TSpeedButton;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  HostBattleForm: THostBattleForm;

implementation

uses WaitForAckUnit, BattleFormUnit, Unit1, Utility, InitWaitFormUnit,
  DisableUnitsFormUnit, HostInfoUnit;

{$R *.dfm}

function ValidatePassword(p: string): Boolean;
var
  i: Integer;
begin
  Result := False;

  for i := 1 to Length(p) do if not (p[i] in ['0'..'9', 'a'..'z', 'A'..'Z']) then Exit;

  Result := True;
end;

procedure THostBattleForm.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure THostBattleForm.Button1Click(Sender: TObject);
var
  i: Integer;
  s: string;
begin
  try
    i := StrToInt(PortEdit.Text);
    if (i < 1024) or (i > 65535) then raise Exception.Create('Number out of range');
  except
    MessageDlg('Port number must be a whole number within a proper range (1024..65535)', mtError, [mbOK], 0);
    Exit;
  end;

  if not (PasswordEdit.Text = '') then if not ValidatePassword(PasswordEdit.Text) then
  begin
    MessageDlg('Invalid password! Must contain letters and numbers only!', mtError, [mbOK], 0);
    Exit;
  end;

  // we have to change mod and update unit list:
  InitWaitForm.ChangeCaption(MSG_MODCHANGE);
  InitWaitForm.TakeAction := 0; // change mod
  InitWaitForm.ShowModal; // this changes mod (see OnFormActivate event)
  // now let's update units:
  InitWaitForm.ChangeCaption(MSG_GETUNITS);
  InitWaitForm.TakeAction := 1; // load unit lists
  InitWaitForm.ShowModal; // this loads unit lists (see OnFormActivate event)
  DisableUnitsForm.VDTUnits.RootNodeCount := UnitNames.Count;

  s := 'OPENBATTLE ';
  // password (must be "*" for none):
  if PasswordEdit.Text = '' then s := s + '* ' else s := s + PasswordEdit.Text + ' ';
  // port:
  s := s + PortEdit.Text + ' ';
  // max. players:
  s := s + IntToStr(PlayersTracker.Value) + ' ';
  // metal:
  s := s + IntToStr(BattleForm.MetalTracker.Value) + ' ';
  // energy:
  s := s + IntToStr(BattleForm.EnergyTracker.Value) + ' ';
  // max. units:
  s := s + IntToStr(BattleForm.UnitsTracker.Value) + ' ';
  // start pos.:
  s := s + IntToStr(BattleForm.StartPosRadioGroup.ItemIndex) + ' ';
  // game end condition:
  s := s + IntToStr(BattleForm.GameEndRadioGroup.ItemIndex) + ' ';
  // hash code:
  s := s + IntToStr(GetModHash(ModsComboBox.Items[ModsComboBox.ItemIndex])) + ' ';
  // map:
  s := s + BattleForm.MapList.Items[BattleForm.MapList.ItemIndex] + #9;
  // title (description):
  if TitleEdit.Text = '' then s := s + '(none)' + #9 else s := s + TitleEdit.Text + #9; // we should not send empty line for title!
  // name of mod:
  s := s + ModsComboBox.Text;

  // send the command:
  MainForm.TryToSendData(s);

  if WaitForAckForm.ShowModal = mrOK then
  begin // success
    Close;
  end
  else
  begin // failure
  end;
end;

procedure THostBattleForm.FormCreate(Sender: TObject);
begin
  ModsComboBox.Items.Assign(Utility.ModList);
  ModsComboBox.ItemIndex := 0;
end;

procedure THostBattleForm.SpeedButton1Click(Sender: TObject);
begin
  HostInfoForm.ShowModal;
end;

end.
