using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Text;

namespace SpringClient
{
	/// <summary>
	/// Summary description for ChatCreate.
	/// </summary>
	public class ChatCreate : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox ChatNameBox;
		private System.Windows.Forms.Label ChatNameLabel;
		private System.Windows.Forms.Button Submit;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public string ChatName
		{
			get
			{
				return ChatNameBox.Text;
			}
		}

		public ChatCreate()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ChatCreate));
			this.ChatNameBox = new System.Windows.Forms.TextBox();
			this.ChatNameLabel = new System.Windows.Forms.Label();
			this.Submit = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// ChatNameBox
			// 
			this.ChatNameBox.Location = new System.Drawing.Point(112, 22);
			this.ChatNameBox.Name = "ChatNameBox";
			this.ChatNameBox.Size = new System.Drawing.Size(176, 20);
			this.ChatNameBox.TabIndex = 0;
			this.ChatNameBox.Text = "";
			// 
			// ChatNameLabel
			// 
			this.ChatNameLabel.Location = new System.Drawing.Point(16, 24);
			this.ChatNameLabel.Name = "ChatNameLabel";
			this.ChatNameLabel.Size = new System.Drawing.Size(91, 16);
			this.ChatNameLabel.TabIndex = 1;
			this.ChatNameLabel.Text = "Chatroom Name";
			// 
			// Submit
			// 
			this.Submit.Location = new System.Drawing.Point(112, 56);
			this.Submit.Name = "Submit";
			this.Submit.TabIndex = 2;
			this.Submit.Text = "Submit";
			this.Submit.Click += new System.EventHandler(this.Submit_Click);
			// 
			// ChatCreate
			// 
			this.AcceptButton = this.Submit;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(306, 96);
			this.Controls.Add(this.Submit);
			this.Controls.Add(this.ChatNameLabel);
			this.Controls.Add(this.ChatNameBox);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "ChatCreate";
			this.Text = "Create New Chatroom";
			this.Load += new System.EventHandler(this.ChatCreate_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void Submit_Click(object sender, System.EventArgs e)
		{
			if ( ValidateInput() )
			{
				DialogResult = DialogResult.OK;
				Close();
			}
		}

		private bool ValidateInput()
		{
			if ( ChatNameBox.Text == "" )
			{
				MessageBox.Show("Chatroom name must not be blank", "Input error");
				return false;
			}
			if ( ChatNameBox.Text.Length > CONSTANTS.MAXCHATNAME )
			{
				MessageBox.Show(string.Format("Chatroom name must have no more than {0} characters", CONSTANTS.MAXCHATNAME), "Input error");
				return false;
			}
			return true;
		}

		private void ChatCreate_Load(object sender, System.EventArgs e)
		{
			ChatNameBox.Focus();
		}
	}
}
